//<c>   Copyright 1988-2000 by Gerry J. Danen; all rights reserved.

//<t>   Go to a different directory

#include"gd_tools.h"


#define pgVERS_ "V2.01"
#define pgTITL_ "Change Directory"
#define pgCOPR_ "1988"


static  UCHAR   new_dir[FS_LEN], parm[STR_LEN], *ptr, *semi_colon ;


void    show_usage( void )
{
    logon(1);
    fprintf( stderr, "Usage:\n\n"
                     "%s [logical_directory]\n\n"
                     "   where [logical_directory] is an environment variable pointing to a new\n"
                     "   directory, for example:\n\n"
                     "\tset HLP=c:\\myhelp\n"
                     "\t%s HLP\n\n",
                     get_global_program_name(), get_global_program_name() );
    PopPath();
    exit( 1 );
}


void    not_moving( void )
{
    fprintf( stderr, "\nStaying in current directory.\a\n\n" );
    PopPath();
    exit( 1 );
}


void    show_logical_assignment( void )
{
    fprintf( stderr, "\n\tLogical name = %s\n\tAssignment   = %s", parm, new_dir );
    not_moving();
}


void    main( int argc, char *argv[] )
{
    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );

    PushPath();
    if ( argc < 2 )                             // no parameters
        show_usage();
    new_dir[0] = EOS ;
    st_cpy( parm, argv[1], STR_LEN );
    _strupr( parm );
    ptr = getenv( parm );
    if ( ! ptr )
    {
        fprintf( stderr, "\nLogical name %s not found in environment", parm );
        not_moving();
    }
    st_cpy( new_dir, ptr, FS_LEN );
    semi_colon = strchr( new_dir, ';' );
    if ( semi_colon )
        *semi_colon = EOS ;
    _strupr( new_dir );
    if ( new_dir[1] == ':' )                    // change to target drive
    {
        if ( SetDrive( new_dir[0] ) == ERROR )
        {
            fprintf( stderr, "\nError going to drive %c:", new_dir[0] );
            show_logical_assignment();
        }
    }
    if ( _chdir( new_dir ) == -1 )
    {
        fprintf( stderr, "\nDirectory %s does not exist", new_dir );
        show_logical_assignment();
    }
    exit( 0 );
}
